/*	:*****************************************************************
	:	"kyb.h"	:	systemgPridehL[{[hECu
	:*****************************************************************
*/
#ifndef	_KYB_H
#define	_KYB_H

#ifndef	_GUIDEFS_H
#	include	"guidefs.h"
#endif
#ifndef	_KKSTR2_H
#	define	_KKSTR2_H
#	include	<kkstr2.h>
#endif

#define	KYBUF_SIZE	(64)

typedef	struct
{	USHORT	ch;
	USHORT	ec;
} KYBUF;

extern	KYBUF	KyBuf[KYBUF_SIZE];
extern	int		KyBufLen;					/* obt@̗L	*/
extern	UINT	KyBufPtr;					/* obt@̌݃|C^	*/
extern	UINT	KyReadPtr;					/* obt@̓Ǎ|C^	*/
extern	char	KyRepCut;					/* s[g֎~				*/
											/* SideWork َ ٺ	*/
extern	char	KanDspFlag;
extern	char	*KanStrPtr;					/* 擾|C^	*/
extern	SHORT	KanX, KanY;					/* m蕶\ʒu	*/
extern	void	(*MiLoopFunc)();			/* m蕶\̎s֐	*/
extern	char	KyHitFlag;					/* L[͂͂H		*/
extern	int		KyMiDsp;					/* m蕶\??		*/


extern	int		kbhit(void);
extern	int		getkey( UINT *ec );
extern	int		inpchk( UINT *ec );
extern	void	KBF_clear(void);
extern	void	KBF_kan_off(void);
extern	void	KBF_kan_on(void);
extern	int		KBF_kan_getMode(void);
extern	void	KBF_kan_setMode(int md);
extern	void	KBF_sysInit(void);
extern	void	KBF_sysEnd(void);
extern	void	KBF_sysPause(void);
extern	void	KBF_sysContinue(void);

#define	KAN_SET_POS(x,y)	{KanX=(x); KanY=(y);}
#define	KAN_SET_STR(s)		{KanStrPtr = (s);}

#ifndef	KAN_ROUMAZIOFF
	/****************************************/
	/*  KAN_setModep萔`               */
	/****************************************/
#	define	KAN_ROUMAZIOFF	0x00000010	/*	ʏ		*/
#	define	KAN_ROUMAZI		0x00000020	/*	[}	*/
#	define	KAN_HANKAKU		0x00000040	/*	p		*/
#	define	KAN_ZENKAKU		0x00000080	/*	Sp		*/
#	define	KAN_EISUU		0x00000100	/*	p		*/
#	define	KAN_KATAKANA	0x00000200	/*	J^Ji	*/
#	define	KAN_HIRAGANA	0x00000400	/*	Ђ炪ȓ	*/
#	define	KAN_MODELOCKOFF	0x00000000	/*	[hŒ	*/
#	define	KAN_MODELOCK	0x00010000	/*	[hŒݒ	*/
#	define	KAN_EISYOU		0x00000000	/*	p		*/
#	define	KAN_EIDAI		0x00020000	/*	p		*/
#endif

#define	KAN_SETMODE_HAN()	KBF_kan_setMode(KAN_HANKAKU|KAN_EISUU|KAN_EISYOU)
#define	KAN_SETMODE_JNP()	{								\
	int		km = KBF_kan_getMode();							\
	if ( km < 0 ) { KBF_kan_on(); km = KBF_kan_getMode();	\
	km = (km & 0xFFFFF0FF) | KAN_HIRAGANA;					\
	KBF_kan_setMode(km);									\
}

#endif
